# coding=UTF-8

import urllib,urllib2,re,xbmcplugin,xbmcgui,xbmc, sys, datetime
from pluginutils.basic import *
import ctscraper
_=xbmc.getLocalizedString

# plugin constants
__plugin__ = "CT"
__author__ = "ivan"
__url__ = ""
__svn_url__ = ""
__version__ = "0.1"
__svn_revision__ = "$Revision$"
__XBMC_Revision__ = "28256"

# Actions

ACTION_BROWSE_SERIES=103
ACTION_LIST_ALPHABET=106
ACTION_LIST_TITLES=107
ACTION_LIST_DATES=108
ACTION_LIST_STATIONS=109
ACTION_SHOW_STATION=110


def do_action(url,mode,params):
    cached=True
    if params.get('post_params'):
        post_params=eval(params.get('post_params'))
    if mode==None or not url:
        print "Listing basic categories"
        #add_dir(_(30010),'start_search' , ACTION_LIST_SEARCHES)
        list_categories(ctscraper.CATEGORIES, ACTION_LIST_PAGE)
        list_categories(ctscraper.CAT_ALPHA, ACTION_LIST_ALPHABET)
        add_dir(ctscraper.CAT_DATE[0], 'list_dates', ACTION_LIST_DATES)
        
           
    elif mode==ACTION_LIST_PAGE:
        print "Listing page"+url
        list_items(url, ctscraper.TopCategoryScraper, ACTION_SHOW_VIDEO, ACTION_LIST_PAGE, page=params.get('page'), data=post_params)
        
            
    elif mode==ACTION_SHOW_VIDEO:
        print "Playing video"+url
        quality=xbmcplugin.getSetting('video_quality')
        play_url(url, ctscraper.scrap_video,quality)
            
    elif mode == ACTION_LIST_ALPHABET:
        print "Listing alphabet"
        cat_id=post_params.get('cat_id')
        list_categories(ctscraper.scrap_alphabet(url,cat_id), ACTION_BROWSE_SERIES)
    
    elif mode == ACTION_BROWSE_SERIES:
        print "Listing titles for "+url
        list_categories(ctscraper.scrap_titles(url), ACTION_LIST_TITLES)
        
    elif mode == ACTION_LIST_TITLES:
        print "Listing page"+url
        list_items(url, ctscraper.TitleListScraper, ACTION_SHOW_VIDEO, ACTION_LIST_TITLES, page=params.get('page'))
        
    elif mode==ACTION_SEARCH:
        print "Searching"
        page = params.get('page')
        q=params.get('query')
        if page:
            search_url=url
        else:
            search_url=novascrapper.SEARCH[1]
            
        r=search(search_url,ScrapSearchResult, ACTION_SHOW_VIDEO, ACTION_SEARCH,page, q)
        if not r:
            return
        
    elif mode==ACTION_LIST_SEARCHES:
        list_searches(ACTION_SEARCH)
        cached=False
        
    elif mode==ACTION_DOWNLOAD:
        quality=xbmcplugin.getSetting('video_quality')
        download_url(url, ctscraper.scrap_video, quality, 'vmw')
        return
    
    elif mode==ACTION_LIST_DATES:
        
        date=params.get('date')
        if date:
            date=map(int, date.split('.'))
            date=datetime.date(date[2], date[1], date[0])
        else:
            date=datetime.date.today()
        list_categories(ctscraper.list_dates(date), ACTION_LIST_STATIONS)
        
        prev_month=ctscraper.prev_month(date)
        add_dir(_(30160)% prev_month.strftime('%b %Y'), 'prev_month', ACTION_LIST_DATES,'', param={'date':prev_month.strftime('%d.%m.%Y')})
        
    elif mode==ACTION_LIST_STATIONS:
        for name, thumb in ctscraper.STATIONS:
            add_dir(name, url, ACTION_SHOW_STATION, thumb, param={'station':name})
            
    elif mode==ACTION_SHOW_STATION:
        station=params.get('station')
        list_items(url, ctscraper.StationScraper, ACTION_SHOW_VIDEO, 0, station)
    
        
    xbmcplugin.endOfDirectory(int(sys.argv[1]), cacheToDisc=cached)

                                   
params=get_params()
url=params.get('url')
mode=params.get('mode')
if mode:
    mode=int(mode)
print "args:",sys.argv
print "Mode: "+str(mode)
print "URL: "+str(url)
print "Params: "+str(params)

try:
    do_action(url, mode, params)
except Exception, e:
    xbmc.log("PYTHON ERROR %s" % str(e), xbmc.LOGERROR)
    traceback.print_exc( file=sys.stdout)
    

